package jp.or.cute.sangokushi.httpclient;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.net.HttpURLConnection;
import java.net.URL;
import java.net.URLEncoder;
import java.util.Iterator;

import android.util.Log;

/*
 * ルーム退室
 * @author iST
 * @version 0.1
 * @since 2010/05/04
*/
public class BattleCommand extends HttpCommand{
/*
	protected final static String BASE_PATH = "http://sangokushidev.cute.or.jp/index.php";
	protected final static int BATTLE_COMMAND_ID = 0;
	
	// 登録されているコマンド（未送信）
	// 送信されると0になる
	private int commandCount = 0;
	private String[] command = new String[2];
*/
	private String mUserid;
	private String mRoomid;

	public void setUserAndRoom(String user,String room)
	{
		mUserid = user;
		mRoomid = room;
	}
	public void MoveCell(int x,int y)
	{
		int cell = y * 45 + x + 1;
		this.setParam(HttpClient.COMMAND_PLAYERID, mUserid);
		this.setParam(HttpClient.COMMAND_LOBBYID, mRoomid);
		this.setParam(HttpClient.PARAMS_MOVEMAPCHIPNO, Integer.toString(cell));
	}
	
	public void BattlePlayer(int x,int y) {
		int cell = y * 45 + x + 1;
		this.setParam(HttpClient.COMMAND_PLAYERID, mUserid);
		this.setParam(HttpClient.COMMAND_LOBBYID, mRoomid);
		this.setParam(HttpClient.PARAMS_BATTLEMAPCHIPNO, Integer.toString(cell));
	}
/*	
    public String httpGet(String location){
        HttpURLConnection http = null;
        InputStream in = null;
        URL url = null;
        String response = null;
        ByteArrayOutputStream baos = new ByteArrayOutputStream();
        try {
            // 指定した URL の作成
        	String urlString = BASE_PATH + "?" + location;
        	Log.d("httpget","urlString="+urlString);
            url = new URL(urlString); //location);
            // HTTP通信の初期化
            http = (HttpURLConnection) url.openConnection();
            // HTTP通信のメソッド指定(今回は取得のみなので GET を指定)
            http.setRequestMethod("GET");
            // UserAgentのセット
            //http.setRequestProperty("User-Agent", "Android Application");
            // HTTP通信開始
            http.connect();
            Log.d("httpget","status="+Integer.toString(http.getResponseCode()));
            // HTTP通信でデータを取得
            in = http.getInputStream();
            int len;
            byte[] buf = new byte[4096];
            while ( (len = in.read(buf))> 0) {
                baos.write(buf, 0, len);
            }
            Log.d("httpget","status="+Integer.toString(http.getResponseCode()));
            // 取得したデータを Stringへ変換
            response = new String(baos.toByteArray());
        } catch (Exception e) {
            e.printStackTrace();
        } finally{
            // HTTP 通信の後始末
            try{
                in.close();
            } catch (Exception e) {}
            try {
                http.disconnect();
            } catch (Exception e) {}
        }
    	Log.d("BattleCommand","response="+response);
        return response;
    }

	
	
	public String httpPost(String cmd) {
        String result = "";
        HttpURLConnection conn = null;
        String postdata = "";

        // post送信データを１本の文字列にまとめる
        try {
    		URL url = new URL(BASE_PATH);
    		Log.d("BattleCommand", "cmd=\"" + cmd +"\"");

            conn = (HttpURLConnection)url.openConnection();
            conn.setReadTimeout(10*1000  m秒 );
            conn.setConnectTimeout(15*1000  m秒 );
            conn.setRequestMethod("POST");
            conn.setDoInput(true);
            conn.setDoOutput(true);
            if (cmd.length() > 0) {
                OutputStreamWriter writer = new OutputStreamWriter(conn.getOutputStream(),"UTF-8");
                writer.write(cmd);
                writer.flush();
                writer.close();
            }
            conn.connect();
            InputStreamReader reader = new InputStreamReader(conn.getInputStream(),"UTF-8");
            while (true) {
            	char[] buffer = new char[4096]; // #chars <= #bytes
            	int nchars = reader.read(buffer);
            	if (nchars < 0)
            		break;
            	result += String.valueOf(buffer, 0, nchars);
            }
        	reader.close();
            Log.d("BattleCommand","result="+result);
        } catch (IOException e) {
            result = null;
            Log.d("BattleCommand","Error message="+e.getMessage());
        } finally {
            if (conn != null) conn.disconnect();
        }
        return result;
    }

*/	public BattleCommand(String sessionID) {
		super(POST,sessionID);
		this.setPath(HttpClient.BASE_PATH);
		this.setParam(HttpClient.PARAMS_COMMAND,HttpClient.COMMAND_SET_BATTLE);
	}
	
	
	public BattleCommand(String userid,String roomid,String sessionID) {
		super(POST,sessionID);
		mUserid = userid;
		mRoomid = roomid;
		this.setPath(HttpClient.BASE_PATH);
		this.setParam(HttpClient.PARAMS_COMMAND,HttpClient.COMMAND_SET_BATTLE);
	}
	
	public BattleCommand(String method,String sessionID) {
		super(POST,sessionID);
		this.setPath(HttpClient.BASE_PATH);
		this.setParam(HttpClient.PARAMS_COMMAND,HttpClient.COMMAND_SET_BATTLE);
	}
}


