package jp.or.cute.sangokushi.twitter;

import jp.or.cute.sangokushi.R;

import org.json.JSONException;
import org.json.JSONObject;

import android.content.Context;


public class TwitterJSON {
	Context mContext;
	
	public TwitterJSON(Context context){
		mContext = context;
	}
	public String getCurrentTweet(JSONObject status) {
		return status.optString("text", (String) getString(R.string.bad_value));
	}

	public String getUserName(JSONObject credentials) {
		return credentials.optString("name", (String) getString(R.string.bad_value));
	}

	public String getLastTweet(JSONObject credentials) {
		try {
			JSONObject status = credentials.getJSONObject("status");
			return getCurrentTweet(status);
		} catch (JSONException e) {
			e.printStackTrace();
			return (String) getString(R.string.tweet_error);
		}
	}

	private CharSequence getString(int resId){
		return mContext.getText(resId);
	}
}