package jp.or.cute.sangokushi.httpclient;

import android.os.Handler;
import android.os.Message;

/**
 * HTTP接続
 * @author iST
 * @version 0.1
 * @since 2010/03/29
 */
public class HttpRunnable implements Runnable {
	private Handler mHandler;
	private HttpClient mClient;

	public HttpRunnable(Handler handler, HttpClient client) {
		mHandler = handler;
		mClient = client;
	}

	@Override
	public void run() {
		Object object = mClient.execute();
		
		Message msg = new Message();
		msg.obj = object;
		mHandler.sendMessage(msg);
	}

}
