package jp.or.cute.sangokushi.twitter;

import oauth.signpost.OAuthConsumer;

import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.params.HttpConnectionParams;
import org.apache.http.params.HttpParams;

import android.os.Handler;

/**
 * Twitter通信
 * @author iST
 * @version 0.1
 * @since 2010/03/29
 */
public class TwitterRunnable implements Runnable{
	private static final int CONNECTION_TIMEOUT = 10000;
	private static final int TIMEOUT = 20000;
	
	private Handler mHandler;
	public Handler getHandler() {
		return mHandler;
	}

	private OAuthConsumer mConsumer;
	public OAuthConsumer getConsumer() {
		return mConsumer;
	}

	private HttpParams mHttpParams;
	
	protected DefaultHttpClient mClient;
	
	public TwitterRunnable(Handler handler, OAuthConsumer consumer){
		mHandler = handler;
		mConsumer = consumer;
		mClient = new DefaultHttpClient();
		
		mHttpParams = mClient.getParams();
		HttpConnectionParams.setConnectionTimeout(mHttpParams, CONNECTION_TIMEOUT); //接続のタイムアウト  
	    HttpConnectionParams.setSoTimeout(mHttpParams, TIMEOUT); //データ取得のタイムアウト
	}

	@Override
	public void run() {
	}
}
