package jp.or.cute.sangokushi.twitter;

import java.io.IOException;

import oauth.signpost.OAuthConsumer;
import oauth.signpost.exception.OAuthCommunicationException;
import oauth.signpost.exception.OAuthExpectationFailedException;
import oauth.signpost.exception.OAuthMessageSignerException;

import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.impl.client.BasicResponseHandler;
import org.json.JSONException;
import org.json.JSONObject;

import android.os.Handler;
import android.os.Message;

/**
 * Twitter通信
 * 	ユーザー情報取得用通信
 * @author iST
 * @version 0.1
 * @since 2010/03/29
 */
public class TwitterUserStatusRunnable extends TwitterRunnable{
	public TwitterUserStatusRunnable(Handler handler, OAuthConsumer consumer) {
		super(handler, consumer);
	}
	
	@Override
	public void run() {
		JSONObject jso = null;
		OAuthConsumer consumer = this.getConsumer();
		
    	HttpGet get = new HttpGet(TwitterOperator.VERIFY_URL_STRING);
    	try {
    		consumer.sign(get);
			String response = mClient.execute(get, new BasicResponseHandler());
			jso = new JSONObject(response);
		} catch (OAuthMessageSignerException e) {
			e.printStackTrace();
		} catch (OAuthExpectationFailedException e) {
			e.printStackTrace();
		} catch (OAuthCommunicationException e) {
			e.printStackTrace();
		} catch (JSONException e) {
			e.printStackTrace();
		} catch (ClientProtocolException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
		
		Handler handler = this.getHandler();
		Message msg = new Message();
		msg.obj = jso;
		handler.sendMessage(msg);
		
	}
}
